Bug 1340635

Summary: PMDK (NVML) does not support ARM architecture
Product: [Fedora] Fedora Reporter: Krzysztof Czurylo <krzysztof.czurylo>
Component: nvmlAssignee: Krzysztof Czurylo <krzysztof.czurylo>
Status: CLOSED EOL QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 32CC: adam.borowski, krzysztof.czurylo, marcin.slusarz
Target Milestone: ---   
Target Release: ---   
Hardware: aarch64   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-05-25 14:56:25 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On:    
Bug Blocks: 245418, 485251, 1470619    

Description Krzysztof Czurylo 2016-05-29 11:19:13 UTC
Description of problem:

1. By design, NVML does not support any 32-bit architecture.
2. Due to dependency on xmmintrin.h and because of using some inline assembly, it builds only for x86_64 at the moment.  Other 64-bit architectures could also be supported, if only there is a request for that, and if somebody provides the arch-specific implementation of the low-level routines for flushing to persistent memory.

Comment 1 Jan Kurik 2016-07-26 04:31:35 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.

Comment 2 Fedora End Of Life 2017-11-16 18:44:58 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 3 Fedora End Of Life 2018-02-20 15:25:10 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 28 development cycle.
Changing version to '28'.

Comment 4 Ben Cotton 2019-02-19 17:08:37 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 30 development cycle.
Changing version to '30'.

Comment 5 Adam Borowski 2019-06-24 05:26:31 UTC
We (Intel) generally don't port software to foreign architectures by our own efforts, merely accept and review external patches.  Yet, PMDK already has support for ARM64 -- it compiles but doesn't (out of the box) work, and superficial investigation suggests that it's a problem with dependencies rather than PMDK itself.

In particular:
* valgrind crashes with SIGILL upon encountering any cache flushes, even those supposed to be supported by any 64-bit ARM machine.  A very preliminary patch is at https://bugs.debian.org/cgi-bin/bugreport.cgi?att=1;bug=930708;filename=0001-Fix-SIGILL-on-dcache-flushes-on-arm64.patch;msg=5
* valgrind reports false positives in helgrind and drd tests
* gcc apparently miscompiles (or possibly reveals a bug/undefined behaviour?) parts of vecx-related code at -O2 or higher.  This can be avoided by building with clang or by lowering gcc's optimization level to -O1, -O0 or -Og.

(I'm posting these findings in case someone is willing to expend effort to fix the above issues.)

Comment 6 Adam Borowski 2019-11-08 16:27:14 UTC
These issues seem to have been fixed -- at least, the testsuite passes.  Still, I'm not aware of any ARM64 hardware that supports real (non-simulated) persistent memory, thus enabling this support in Fedora/Red Hat is not exactly a priority.  If someone wishes to drive this effort, at least some more extensive testing would be a good idea.

Comment 7 Ben Cotton 2020-02-11 15:43:54 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 32 development cycle.
Changing version to 32.

Comment 8 Fedora Program Management 2021-04-29 15:52:26 UTC
This message is a reminder that Fedora 32 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 32 on 2021-05-25.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '32'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 32 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 9 Ben Cotton 2021-05-25 14:56:25 UTC
Fedora 32 changed to end-of-life (EOL) status on 2021-05-25. Fedora 32 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.